Intro
=====

watch-my-terminal is a little utility that enables people to watch your
terminal using just a web browser. This is achieved by having ``script`` send
its log to a tiny web server (thank you node.js) with realtime updates helped
along by the socket.io library.

The terminal emulation is far from complete, but sufficient to correctly render
vim (with color, etc), less, man, ls --color, etc. when run in
rxvt-unicode-256color


Install
=======

To run watch-my-terminal, you'll need coffeescript and a node library called
socket.io. socket.io depends on several other node libraries, so it's
recommended to install it with npm. 

1.	Install coffeescript and npm with your package manager. On debian-family
	distros that would look something like this:

		apt-get install coffee-script npm

2.	Download socket.io (into a sub-directory of this folder.) First make sure
	you cd into the watch-my-terminal directory (where you should see the
	package.json file for watch-my-terminal) and then execute:

		npm install

The other dependency is "script" which in installed by default on pretty much
all Linux installations. I've heard that there is an old BSD version which is
incompatible.

I have only tested this on debian unstable. Please contact jason@jasonwoof.com
if you are aware of what different or additional steps are required for other
systems.


Configure
=========

For many programs to render correctly, you'll need to configure
watch-my-terminal to use the exact same dimensions as your terminal. Run this:

	echo $LINES $COLUMNS

and then edit server.coffee. At the top you will see where you can set the
number of lines and columns, and (if you wish) change the port.


Run
===

To start making your terminal viewable, cd to this directory, and run:

	./run.sh

Then test that it's working by opening up http://localhost:2218/ in your
favorite web browser (assuming your favorite web-browser does javascript.)

watch-my-terminal listens on all your ip addresses by default, so your terminal
contents are now accessible to the whole network. Also, you can replace
"localhost" in that link with something that points at your computer, and share
the link with others on your network (or the internet if you're not
firewalled.)


Feedback, Questions, Bugs, etc.
===============================

Please direct your questions, statements, interjections, etc to the author:

	Jason Woofenden <jason@jasonwoof.com>
